package yrpg.bamp.basedata.plugin.form.mobile;

import kd.bos.bill.AbstractMobBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 单据界面插件(移动端)
 */
public class DepartmentFilterEntryMobBillPlugin extends AbstractMobBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        IDataModel parentModel = this.getView().getParentView().getModel();
        String formId = parentModel.getDataEntityType().toString();
        DynamicObject baseData = BusinessDataServiceHelper.loadSingle("yrpg_expensefilt", new QFilter[]{new QFilter("number", QCP.equals, formId)});
        if (baseData != null) {
            String depIdentifying = baseData.getString("yrpg_department");

            BasedataEdit basedataEdit = this.getControl(depIdentifying);
            basedataEdit.addBeforeF7SelectListener(this);
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        String fieldName = beforeF7SelectEvent.getProperty().getName();
        IDataModel parentModel = this.getView().getParentView().getModel();
        String formId = parentModel.getDataEntityType().toString();
        DynamicObject baseData = BusinessDataServiceHelper.loadSingle("yrpg_expensefilt", new QFilter[]{new QFilter("number", QCP.equals, formId)});
        if (baseData != null) {
            String depIdentifying = baseData.getString("yrpg_department");
            String comIdentifying = baseData.getString("yrpg_company");
            boolean ifcomhead = baseData.getBoolean("yrpg_ifcompanyhead");
            boolean ifdephead = baseData.getBoolean("yrpg_ifdepartmenthead");
            if (depIdentifying.equals(fieldName)) {
                if (ifcomhead && !ifdephead) {
                    //公司表头、部门表体
                    DynamicObject company = (DynamicObject) parentModel.getValue(comIdentifying);
                    if (company != null) {
                        String companyLongName = "";
                        DynamicObjectCollection structure = company.getDynamicObjectCollection("structure");
                        for (DynamicObject dynamicObject : structure) {
                            companyLongName = dynamicObject.getString("fullname");
                            break;
                        }
                        QFilter qFilter = new QFilter("structure.fullname", QCP.like, "%" + companyLongName + "%");
                        List<Long> ids = new ArrayList<>();
                        for (DynamicObject dynamicObject : BusinessDataServiceHelper.load("bos_org", "id", new QFilter[]{qFilter})) {
                            ids.add(dynamicObject.getLong("id"));
                        }
                        beforeF7SelectEvent.getFormShowParameter().setCustomParam("range", ids);

                    }
                } else if (!ifcomhead && !ifdephead) {
                    //公司部门都在表体
                    String entryIdentifying = baseData.getString("yrpg_entry");
                    int index = this.getModel().getEntryCurrentRowIndex(entryIdentifying);
                    DynamicObject company = (DynamicObject) this.getModel().getValue(comIdentifying, index);
                    if (company != null) {
                        String companyLongName = "";
                        DynamicObjectCollection structure = company.getDynamicObjectCollection("structure");
                        for (DynamicObject dynamicObject : structure) {
                            companyLongName = dynamicObject.getString("fullname");
                            break;
                        }
                        QFilter qFilter = new QFilter("structure.fullname", QCP.like, "%" + companyLongName + "%");
                        List<Long> ids = new ArrayList<>();
                        for (DynamicObject dynamicObject : BusinessDataServiceHelper.load("bos_org", "id", new QFilter[]{qFilter})) {
                            ids.add(dynamicObject.getLong("id"));
                        }
                        beforeF7SelectEvent.getFormShowParameter().setCustomParam("range", ids);
                    }
                }
            }
        }
    }
}